#!/usr/bin/perl

$varID = 0;

open input, "<$ARGV[0]"; #input CGI var file
open output, ">$ARGV[1]"; #output GVF file

#Pragma
print output "##gvf-version 1.05\n";
print output "##file-version 1.0\n";
print output "##feature-ontology http://sourceforge.net/projects/song/files/Sequence%20Ontology/so_2_4_4/so_2_4_4.obo/download\n";
print output "##genome-build NCBI B36.3\n";
print output "##sequence-region\n";
print output "##technology-platform Complete Genomics WGS\n";

$source = 'CGI';

$strand = '+';
$phase = '.';

#initialize last variant
$last_ploidy = '';	
$last_allele = '';
$last_chromosome = '';
$last_begin = '';
$last_end = '';
$last_varType = '';
$last_reference = '';
$last_variant_call = '';
$last_score = '';

$last_begin_gvf = '';
$last_end_gvf = '';
$last_reference_gvf = '';
$last_variant_gvf = '';

$last_genotype = '';

#read each variant from var file
while ($line = readline input)
{
	#get each var 
	chomp($line);
	if ($line =~ m/^(\d+)\t(\d+)\t(\d+)\t([^\t]+)\t(\d+)\t(\d+)\t([^\t]+)\t([^\t]*)\t([^\t]*)\t(\d+)\t/)
	{
		
		$ploidy = $2;	
		$allele = $3;
		$chromosome = $4;
		$begin = $5;
		$end = $6;
		$varType = $7;
		$reference = $8;
		$variant_call = $9;
		$score = $10;
				
		$begin_gvf = 0;
		$end_gvf = 0;
		
		$is_var = 0;
		$avg_score = 0;
		
		#convert half-open, zero-based to 1-based coordinate system
		if ($varType eq 'snp')
		{
			$is_var = 1;
			$begin_gvf = $begin + 1;
			$end_gvf = $begin_gvf;
			$varType = 'SNV';
			$reference_gvf = $reference;
			$variant_gvf = $variant_call;
		}
		elsif ($varType eq 'ins')
		{
			$is_var = 1;
			$begin_gvf = $begin;
			$end_gvf = $begin_gvf;
			$varType = 'insertion';
			$reference_gvf = '-';
			$variant_gvf = $variant_call;
		}
		elsif ($varType eq 'del')
		{
			$is_var = 1;
			$begin_gvf = $begin + 1;
			$end_gvf = $end;
			$varType = 'deletion';
			$reference_gvf = $reference;
			$variant_gvf = '-';
		}
		elsif ($varType eq 'sub')
		{
			$is_var = 1;
			$begin_gvf = $begin + 1;
			$end_gvf = $end;
			$varType = 'complex_substitution';
			$reference_gvf = $reference;
			$variant_gvf = $variant_call;
		}
		
		if ($is_var == 1)
		{
			#compare this variant with previous variant
			if ($chromosome eq $last_chromosome && $begin == $last_begin && $end == $last_end && $reference eq $last_reference && $variant_call eq $last_variant_call)
			{
				
				if ($chromosome ne 'chrX' && $chromosome ne 'chrY' && $chromosome ne 'chrM')
				{
					$last_genotype = 'homozygous';
				}
				elsif ($chromosome eq 'chrX' && $ploidy == 2)
				{
					$last_genotype = 'homozygous';
				}
				
				#update genotype and score, but don't print
				$last_score = sprintf("%d", (($score + $last_score)/2) );
				$avg_score = 1;
			}
			else
			{
				#print the last variant
				if ($last_chromosome ne '')
				{
					$varID = $varID + 1;
					print output "$last_chromosome\t$source\t$last_varType\t$last_begin_gvf\t$last_end_gvf\t$last_score\t$strand\t$phase\tID=$varID;Reference_seq=$last_reference_gvf;Variant_seq=$last_variant_gvf;Genotype=$last_genotype;\n";
				}
				
				if ($chromosome ne 'chrX' && $chromosome ne 'chrY' && $chromosome ne 'chrM')
				{
					$last_genotype = 'heterozygous';
				}
				elsif ($chromosome eq 'chrX' && $ploidy == 1)
				{
					$last_genotype = 'homozygous';
				}
				elsif ($chromosome eq 'chrX' && $ploidy == 2)
				{
					$last_genotype = 'heterozygous';
				}
				elsif ($chromosome eq 'chrY' && $ploidy == 1)
				{
					$last_genotype = 'homozygous';
				}
				elsif ($chromosome eq 'chrM' && $ploidy == 1)
				{
					$last_genotype = 'homozygous';
				}
							
				
			}
			
			#update last variant
			$last_ploidy = $ploidy;	
			$last_allele = $allele;
			$last_chromosome = $chromosome;
			$last_begin = $begin;
			$last_end = $end;
			$last_varType = $varType;
			$last_reference = $reference;
			$last_variant_call = $variant_call;
			
			if ($avg_score == 0)
			{
				$last_score = $score;
			}
						
			$last_begin_gvf = $begin_gvf;
			$last_end_gvf = $end_gvf;
			$last_reference_gvf = $reference_gvf;
			$last_variant_gvf = $variant_gvf;
		}
		
	}

}

#print the last variant
if ($is_var == 1)
{
	$varID = $varID + 1;
	print output "$last_chromosome\t$source\t$last_varType\t$last_begin_gvf\t$last_end_gvf\t$last_score\t$strand\t$phase\tID=$varID;Reference_seq=$last_reference_gvf;Variant_seq=$last_variant_gvf;Genotype=$last_genotype;\n";
}

close output;

	
	

	
		


